/*
 * base_entity.cpp
 *
 *  Created on: Apr 10, 2010
 *      Author: leden
 */

#include "base_entity.h"

#include <cstdio>

BaseEntity::BaseEntity() {
	init(UNDEFINED_ID, "");
}

BaseEntity::BaseEntity(Id id) {
	init(id);
}

BaseEntity::BaseEntity(Id id, const std::string& name) {
	init(id, name);
}

int BaseEntity::id() const {
	return id_;
}

void BaseEntity::set_id(int id) {
	id_ = id;
}

std::string BaseEntity::name() const {
	return name_;
}

void BaseEntity::set_name(const std::string& name) {
	name_ = name;
}

void BaseEntity::init(Id id, const std::string& name) {
	set_id(id);
	set_name(name);
}

void BaseEntity::init(Id id) {
	static char buff[20];
	sprintf(buff, "%d", id); //TODO
	init(id, buff);
}

std::ostream& operator<<(std::ostream& os, const BaseEntity& b) {
	os << "BaseEntity(id=" << b.id() << "; name=" << b.name() << ")";
	return os;
}
