/*
 * base_entity.h
 *
 *  Created on: Apr 10, 2010
 *      Author: leden
 */

#ifndef BASE_ENTITY_H_
#define BASE_ENTITY_H_

#include <string>
#include <iostream>

typedef int Id;

class BaseEntity {
public:
	static const Id UNDEFINED_ID = -1LL;
private:
	Id id_;
	std::string name_;

public:
	BaseEntity();
	BaseEntity(Id id);
	BaseEntity(Id id, const std::string& name);
	Id id() const;
	void set_id(Id id);
	std::string name() const;
	void set_name(const std::string& name);
protected:
	void init(Id id);
	void init(Id, const std::string& name);

	friend std::ostream& operator<<(std::ostream& os,
			const BaseEntity& base_entity);

//	friend class EntityFactory;
};

#endif /* BASE_ENTITY_H_ */
