/*
 * buyer_request.h
 *
 *  Created on: May 26, 2010
 *      Author: leden
 */

#ifndef BUYER_REQUEST_H_
#define BUYER_REQUEST_H_

#include "boost/shared_ptr.hpp"

#include "base_entity.h"
#include "base_types.h"
#include "constraint.h"
#include "purchasable.h"

#include <vector>
#include <iostream>

class BuyerRequest : public BaseEntity {
private:
	boost::shared_ptr< Constraint<Purchasable> > constraint_;
	int quantity_;
	int met_count_;
	bool disjunctive_;
public:
	BuyerRequest(Constraint<Purchasable>* purchasable_constraint,
			Quantity quantity, bool disjunctive = true);
	const Constraint<Purchasable>& constraint() const;
	bool incrementMetCount(int inc = 1);
	bool decrementMetCount(int dec = 1);
	bool set_met_count(int met_count);
	int met_count() const;
	bool isMet() const;
	int remainingUntilMet() const;
	Quantity quantity() const;
	bool isDisjunctive() const;
	virtual ~BuyerRequest();

	friend std::ostream& operator<<(std::ostream& os, const BuyerRequest& br);
};

#endif /* BUYER_REQUEST_H_ */
