/*
 * Currency.h
 *
 *  Created on: Apr 10, 2010
 *      Author: leden
 */

#ifndef CURRENCY_H_
#define CURRENCY_H_

#include "base_entity.h"
#include "price_utils.h"
#include "entity_io_utils.h"

#include <string>
#include <map>
#include <iostream>

class Currency : public BaseEntity {
private:
	static const Currency* base_;
	static const double defaultPriceUnitsPerUnitValue = 100;
	static double price_units_per_unit_value_;
	static std::map<std::string, Currency> currencies_;

	std::string code_;
	double relative_rate_;
public:
	Currency(std::string code, double relativeRate);
	const std::string& code() const;
	double relative_rate() const;
	double getValue(Price price) const;
	Price getPrice(double value_in_currency) const;
	Price convert(const Currency& to) const;
	static const Currency* setBase(const Currency& baseCurrency,
			double priceUnitsPerUnitValue);
	static const Currency* getCurrency(const std::string& code);
	static const Currency* base_currency();

	static const std::map<std::string, Currency>& currencies();
	friend std::ostream& operator<<(std::ostream& os, const Currency& c);

	friend class EntityIOUtils;
};


#endif /* CURRENCY_H_ */
