/*
 * EntityFactory.h
 *
 *  Created on: Apr 16, 2010
 *      Author: leden
 */

#ifndef ENTITY_FACTORY_H_
#define ENTITY_FACTORY_H_

#include <cstdio>
#include <cstdlib>
#include <ctime>

template<typename T>
class EntityFactory {
private:
	unsigned seed_val_;
	unsigned* seed_;
public:
	EntityFactory() {
		init((unsigned)time(NULL));
	}
	EntityFactory(unsigned seed) {
		init(seed);
	}
	virtual T createEntity() = 0;
	unsigned seed_value() const { return seed_val_; }
	virtual ~EntityFactory() {
	}
protected:
	unsigned* seed() { return seed_; }
private:
	void init(unsigned seed) {
		seed_val_ = seed;
		seed_ = &seed_val_;
		printf("Created factory with seed: %u!\n", seed);
	}
};

#endif /* ENTITY_FACTORY_H_ */
