/*
 * ga_selector.h
 *
 *  Created on: May 30, 2010
 *      Author: leden
 */

#ifndef GA_SELECTOR_H_
#define GA_SELECTOR_H_

#include <ecf/ECF.h>
#include "ga_fitness_eval.h"

#include "flow_based_selector.h"
#include "purchasable_offer.h"

class GASelector : public FlowBasedSelector {
private:
	StateP state_;
	vector<const PurchasableOffer*> offers_;
	bool in_progress_;

public:
	GASelector(Market& market, PurchasableData& purchasable_data,
			const string& param_file, const string& argv0,
			int buy_offer_limit = -1);
	virtual bool start(
			const std::vector<BuyerRequest>& purchasable_requests,
			const Constraint<Seller>& seller_constraint,
			const Constraint<Selection>& selection_constraint);
	virtual bool stop();
	const PurchasableOffer& getOffer(int n) const;

	bool isInProgress() const;
protected:
	bool isCurrentSelectionFeasible() const;
private:
	int calcOfferBuyLimit();

	friend class GAFitnessEvalOp;
};

#endif /* GA_SELECTOR_H_ */
