/*
 * greedy_selector.h
 *
 *  Created on: May 29, 2010
 *      Author: leden
 */

#ifndef GREEDY_SELECTOR_H_
#define GREEDY_SELECTOR_H_

#include "selector.h"

class GreedySelector : public Selector {
private:
	std::vector<PurchasableOffer> offers_by_price_;
	std::map<Id, int> unmatched_purchasables_;
public:
	GreedySelector(Market& market, const PurchasableData& purchasable_data);
	virtual ~GreedySelector();
	virtual bool start(
			const std::vector<BuyerRequest>& purchasable_requests,
			const Constraint<Seller>& seller_constraint,
			const Constraint<Selection>& selection_constraint);
	virtual bool stop();

protected:
	virtual Quantity selectOffer(const PurchasableOffer& offer,
			Quantity quantity = 1);
	virtual Quantity deselectOffer(const PurchasableOffer& offer,
			Quantity quantity = 1);

	virtual int match(Id purchasable_id, int times);
	virtual void addForMatch(Id purchasable_id, int times);
private:
	void matchAsMuchAsPossible();
};

#endif /* GREEDY_SELECTOR_H_ */
