/*
 * market.cpp
 *
 *  Created on: Apr 11, 2010
 *      Author: leden
 */

#include "market.h"
#include "string_utils.h"
#include "purchasable_data.h"
#include "currency.h"

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <vector>

Market Market::instance_;

void Market::registerSeller(const Seller& seller) {
	printf("Registering seller:\n");
	cout << seller;
	sellers_.insert(make_pair(seller.id(), seller));
}

std::vector<const Seller*> Market::getSellers() const {
	vector<const Seller*> ret;
	FORC(it, sellers_)
		ret.push_back(&it->second);
	return ret;
}

std::vector<Seller*> Market::sellers() {
	vector<Seller*> ret;
	FORC(it, sellers_) {
		ret.push_back(&it->second);
	}
	return ret;
}

Seller* Market::seller(Id id) {
	if(!sellers_.count(id))
		return NULL;
	return &sellers_.at(id);
}

std::vector<const PurchasableOffer*> Market::getAllOffers() const {
	vector<const PurchasableOffer*> ret;
	vector<const Seller*> _sellers = getSellers();
	FORC(s, _sellers) {
		vector<const PurchasableOffer*> offers = (*s)->allOffers();
		FORC(o, offers) {
			ret.push_back(*o);
		}
	}
	return ret;
}
