/*
 * market.h
 *
 *  Created on: Apr 11, 2010
 *      Author: leden
 */

#ifndef MARKET_H_
#define MARKET_H_

#include "seller.h"
#include "purchasable_offer.h"

#include <map>
#include <vector>
#include <string>

class Seller;
class PurchasableOffer;

class Market {
private:
	static Market instance_;
	std::map<Id, Seller> sellers_;
public:
	void registerSeller(const Seller& seller);
	std::vector<const Seller*> getSellers() const;
	std::vector<Seller*> sellers();
	Seller* seller(Id id);
	std::vector<const PurchasableOffer*> getAllOffers() const;
private:
//	Property toNameProperty(const PurchasableOffer& offer);
//	std::string fromNameProperty(const std::string& value);
//	Property toOfferContentsProperty(const PurchasableOffer& offer);
//	std::map<Id, Quantity> toOfferContentsProperty(const PurchasableOffer& offer);
//	std::string fromOfferContentsProperty(const std::string& value);
//	std::string toOfferRequirementsProperty(const std::string& value);
//	std::string fromOfferRequirementProperty(const std::string& value);
//	std::string toOfferPriceProperty(Price price);
//	Price fromOfferPriceProperty(const std::string& value);

	friend class EntityIOUtils;
};

#endif /* MARKET_H_ */
