/*
 * properties_entity.cpp
 *
 *  Created on: Apr 13, 2010
 *      Author: leden
 */

#include "properties_entity.h"
#include "property.h"

PropertiesEntity::PropertiesEntity() {
}

PropertiesEntity::PropertiesEntity(Id id) : BaseEntity(id) {

}
PropertiesEntity::PropertiesEntity(Id id, std::string name) : BaseEntity(id, name) {
}

void PropertiesEntity::addProperty(const Property& property) {
	props_.insert(make_pair(property.name(), property.value()));
}

void PropertiesEntity::setProperty(const std::string& key,
		const std::string& value) {
	addProperty(Property(key, value));
}

void PropertiesEntity::clearProperties() {
	props_.clear();
}

const std::map<string, string>& PropertiesEntity::properties() const {
	return props_;
}
