/*
 * BaseEntity.h
 *
 *  Created on: Apr 10, 2010
 *      Author: leden
 */

#ifndef PURCHASABLE_H_
#define PURCHASABLE_H_

#include "properties_entity.h"
#include "utils.h"

#include <map>
#include <string>
using namespace std;

enum PurchasableType {
	PRODUCT,
	SERVICE
};

class Purchasable : public PropertiesEntity {
private:
	double amount_;
	PurchasableType type_;
public:
	Purchasable();
	double amount() const;
	PurchasableType type() const;
	friend bool operator<(const Purchasable& a, const Purchasable& b);
	friend bool operator==(const Purchasable& a, const Purchasable& b);
	friend ostream& operator<<(ostream& os, const Purchasable& p);
};

#endif /* PURCHASABLE_H_ */
