/*
 * purchasable_data.cpp
 *
 *  Created on: Apr 11, 2010
 *      Author: leden
 */

#include "purchasable_data.h"
#include "purchasable.h"
#include "utils.h"
#include "string_utils.h"

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
using namespace std;

PurchasableData PurchasableData::instance_;

PurchasableData::PurchasableData() {
	init();
}

void PurchasableData::init() {
	//TODO
}

PurchasableData& PurchasableData::instance() {
	return PurchasableData::instance_;
}

void PurchasableData::addPurchasable(const Purchasable& p) {
	purchasables_.insert(make_pair(p.id(), p));
}

void PurchasableData::clearPurchasables() {
	purchasables_.clear();
}

const Purchasable* PurchasableData::getPurchasable(Id id) const {
	return (purchasables_.find(id) != purchasables_.end())
			? &purchasables_.at(id) : NULL;
}

vector<const Purchasable*> PurchasableData::getPurchasables() const {
	vector<const Purchasable*> ret;
	FORC(it, purchasables_)
		ret.push_back(&it->second);
	return ret;
}

int PurchasableData::size() const {
	return purchasables_.size();
}
