/*
 * purchasable_data.h
 *
 *  Created on: Apr 11, 2010
 *      Author: leden
 */

#ifndef PURCHASABLE_DATA_H_
#define PURCHASABLE_DATA_H_

#include "purchasable.h"
#include <map>
#include <vector>

class PurchasableData {
private:
	std::map<Id, Purchasable> purchasables_;
	static PurchasableData instance_;
public:
	PurchasableData();
//	bool inputPurchasables(char *filename);
//	bool outputPurchasables(char *filename) const;
	void clearPurchasables();
	const Purchasable* getPurchasable(Id id) const;
	std::vector<const Purchasable*> getPurchasables() const;
	static PurchasableData& instance();
	void addPurchasable(const Purchasable& p);
	int size() const;
private:
	void init();

	friend class EntityIOUtils;
};

#endif /* PURCHASABLE_DATA_H_ */
