/*
 * string_utils.cpp
 *
 *  Created on: Apr 13, 2010
 *      Author: leden
 */

#include "string_utils.h"

#include <sstream>
#include <vector>
#include <set>

/**
 * Razdvaja string na temelju znakova u nizu delimiters.
 * Npr. split("a,b,cd.efg,", ",.") -> "a", "b", "cd", "efg"
 */
std::vector<std::string> StringUtils::split(const std::string& s,
		const std::string& delimiters) {
	std::vector<std::string> tokens;
	std::set<char> delim(delimiters.begin(), delimiters.end());
	int last = 0;
	for ( int i = 0; i <= (int)s.size(); ++i ) {
		if ( i == (int)s.size() || delim.find(s[i]) != delim.end() ) {
			if(i-last >= 1)
				tokens.push_back(std::string(s.begin()+last, s.begin()+i));
			last = i+1;
		}
	}
	return tokens;
}

//std::string StringUtils::to_bitstring(int mask, int n) {
//	std::string ret;
//	for(int i = n-1; i >= 0; --i)
//		ret.push_back(((1<<i) & mask) ? '1' : '0');
//	return ret;
//}
