/*
 * test_bf.h
 *
 *  Created on: May 26, 2010
 *      Author: leden
 */

#ifndef TEST_BF_H_
#define TEST_BF_H_

#include "brute_force_selector.h"
#include "entity_io_utils.h"
#include "buyer_request.h"
#include "string_utils.h"
#include "purchasable.h"

#include <vector>
#include <iostream>

using namespace std;

namespace test {

void testBF(Market& market, const string& filename) {

	NoConstraint<Seller> seller_constr;
	NoConstraint<Selection> selection_constr;
	vector<BuyerRequest> reqs;

	if(!EntityIOUtils::loadRequests(reqs, filename)) {
		cerr << "Error loading requests" << endl;
	}

	cout << StringUtils::to_string(reqs.begin(), reqs.end(), ",") << endl;

	BruteForceSelector bfs(market, PurchasableData::instance());
	if(bfs.start(reqs, seller_constr, selection_constr)) {
		cout << "Found solution: \n" << endl;
		cout << bfs.best_selection() << endl;
	}
	else {
		cerr << "Failed to find solution with brute force!" << endl;
	}

}

}

#endif /* TEST_BF_H_ */
