/*
 * test_greedy.h
 *
 *  Created on: May 29, 2010
 *      Author: leden
 */

#ifndef TEST_GREEDY_H_
#define TEST_GREEDY_H_

#include "greedy_selector.h"
#include "entity_io_utils.h"
#include "buyer_request.h"
#include "string_utils.h"
#include "purchasable.h"

#include <vector>
#include <iostream>

using namespace std;

namespace test {

void testGreedy(Market& market, const string& filename) {
	NoConstraint<Seller> seller_constr;
	NoConstraint<Selection> selection_constr;
	vector<BuyerRequest> reqs;

	if(!EntityIOUtils::loadRequests(reqs, filename)) {
		cerr << "Error loading requests" << endl;
	}

	cout << StringUtils::to_string(reqs.begin(), reqs.end(), ",") << endl;

	GreedySelector gs(market, PurchasableData::instance());
	if(!gs.start(reqs, seller_constr, selection_constr)) {
		cerr << "Failed to find solution with greedy" << endl;
	}
//	cout << gs.selection() << endl;
}

}


#endif /* TEST_GREEDY_H_ */
