/*
 * test_requests.h
 *
 *  Created on: May 28, 2010
 *      Author: leden
 */

#ifndef TEST_REQUESTS_H_
#define TEST_REQUESTS_H_

#include "entity_io_utils.h"
#include "seller.h"

namespace test {

void testRequests(Market& market, const string& filename) {

	vector<BuyerRequest> reqs;
	if(!EntityIOUtils::loadRequests(reqs, filename)) {
		cerr << "Error loading requests" << endl;
	}

	vector<Seller*> sellers = market.sellers();

	cout << "Requests: \n" << StringUtils::to_string(reqs.begin(), reqs.end(), "\n");
	FORC(it, reqs) {
		cout << "q(" << *it << ") = " << it->quantity() << endl;
	}

	FORC(s, sellers) {
		vector<const PurchasableOffer*> offers = (*s)->allOffers();
		FORC(o, offers) {
			FORC(r, reqs) {
				cout << "Offer " << (*o)->name()
								<< " matches " << r->name()
								<< ": " << (*o)->meetsConstraint(r->constraint())
								<< endl;
			}
		}
	}

}

}

#endif /* TEST_REQUESTS_H_ */
