/*
 * time_counter.cpp
 *
 *  Created on: Apr 23, 2010
 *      Author: leden
 */

#include "time_counter.h"

TimeCounter::TimeCounter() : time_running_(0) {
}

bool TimeCounter::stopTimer()
{
	if(!isTimeRunning())
		return false;
	gettimeofday(&end_time_, NULL);
	time_running_ = false;
	return true;
}



double TimeCounter::getElapsedTime() const
{
	if(isTimeRunning()) {
		timeval now;
		gettimeofday(&now, NULL);
		return getDifference(start_time_, now);
	}
	return getDifference(start_time_, end_time_);
}

bool TimeCounter::startTimer()
{
	if(isTimeRunning())
		return false;
	gettimeofday(&start_time_, NULL);
	time_running_ = true;
	return true;
}

bool TimeCounter::isTimeRunning() const
{
	return time_running_;
}

#include <iostream>
double TimeCounter::getDifference(const timeval& from, const timeval& to) const
{
	return (to.tv_sec-from.tv_sec)*1000.0
			- (to.tv_usec-from.tv_usec)/1000.0;
}

